/**
 * regtable.h
 *
 * Copyright (c) 2011 Daniel Berenguer <dberenguer@usapiens.com>
 * 
 * This file is part of the panStamp project.
 * 
 * panStamp  is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 * 
 * panStamp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with panStamp; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 
 * USA
 * 
 * Author: Daniel Berenguer
 * Creation date: 03/31/2011
 */

#ifndef _REGTABLE_H
#define _REGTABLE_H

#include "Arduino.h"
#include "register.h"
#include "commonregs.h"

/**
 * Register indexes
 */

DEFINE_COMMON_REGINDEX_START()
  REGI_RGBLEVELS,
  REGI_IR_RECV,
  REGI_INTERNALTEMP,
  REGI_POWER_ON_STATE,
  REGI_COMMAND,
  REGI_REPEATERCFG,
  REGI_BRIGHTNESS,
  REGI_DMX,
  REGI_LED_POWER,
  REGI_IR_SEND,
DEFINE_COMMON_REGINDEX_END()

inline void copySwapped2( byte *from, byte *to ) { to[0] = from[1]; to[1] = from[0]; };
inline void copySwapped4( byte *from, byte *to ) { to[0] = from[3]; to[1] = from[2]; to[2] = from[1]; to[3] = from[0]; };

#endif

